package cn.net.caoyao.cpzshandset.service.presenter.impl.pack.commonfarmers;

import java.util.ArrayList;
import java.util.List;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.view.View;
import android.widget.Toast;
import cn.net.caoyao.cpzshandset.bean.ConfigBean;
import cn.net.caoyao.cpzshandset.bean.PackBean;
import cn.net.caoyao.cpzshandset.bean.PackPackageInfoBean;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.HandsetVersionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.common.util.NetWorkUtils;
import cn.net.caoyao.cpzshandset.service.bll.PackPackageBll;
import cn.net.caoyao.cpzshandset.service.bll.PackSubLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.ProductBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.caoyao.cpzshandset.service.bll.config.ConfigBll;
import cn.net.caoyao.cpzshandset.service.presenter.OptionHisListStyleConstact;
import cn.net.caoyao.cpzshandset.service.presenter.base.impl.OptionHisListStyleConstactImpl;
import cn.net.caoyao.cpzshandset.service.thread.ThreadPoolManager;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonCheckPackLabelThread;
import cn.net.caoyao.cpzshandset.service.thread.impl.common.CommonSubmitSinglePackThread;
import cn.net.caoyao.cpzshandset.ui.activity.ActivateConfigActivity;
import cn.net.caoyao.cpzshandset.ui.activity.SingleLabelScannerActivity;
import cn.net.caoyao.cpzshandset.ui.adapter.PackageListAdapter;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog;
import cn.net.caoyao.cpzshandset.ui.dialog.OperationDialog.DClick;
import cn.net.caoyao.cpzshandset.ui.dialog.TipsDialog.DSure;
import cn.net.caoyao.cpzshandset.ui.weight.DialogUtils;
import cn.net.handsetlib.utils.ReadDeviceIDUtil;

public class CommonFarmersPackSubListPresenter extends OptionHisListStyleConstactImpl {
	private final OptionHisListStyleConstact.View hisView;
	private Context context;
	private PackageListAdapter adapter;
	private List<PackPackageInfoBean> packBeans = new ArrayList<PackPackageInfoBean>();
	private int createActivateConfigReqCode = 1001;
	private int modifyActivateConfigReqCode = 1002;
//	private ActivateWithPackBll bll;
	private PackBean currentPackBean;
	private PackPackageBll packageBll;
	private PackSubLabelBll subLabelBll;
	private ConfigBll configBll;
	private ProductBll productBll;
	private UploadStatusBll uploadStatusBll;
	private TipsDialog tipsDialog;
	private OperationDialog operationDialog;
	private ProgressDialog bProgressDialog = null;
	private int currentHansetVersion = HandsetVersionConstant.HANDSET_UNIVERSAL_VERSION_MODE_FARMERS;
	private HandsetOperation option_type = HandsetOperation.OPERATION_PACK_CONSTANT;
	private int option_id = -1;

	private Handler mHandler = new Handler() {
		public void handleMessage(android.os.Message msg) {
			switch (msg.what) {
			case RequestConstant.SUBMIT_ALL_PACK_COMPLETE:
				dismissProgress();
				onResume();
				break;
			case RequestConstant.REQUEST_FAIL:
				// 请求失败
				if (!checkViewAvailable())
					return;
				dismissProgress();
				hisView.showMsgToast("请求失败！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT:
				// 超时
				if (!checkViewAvailable())
					return;
				dismissProgress();
				hisView.showMsgToast("请求超时！", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.REQUEST_PROT01_LOGIN_FAIL:
				// 登录失败
				if (!checkViewAvailable())
					return;
				dismissProgress();
				String errorMsg = msg.obj.toString();
				int errorCode = msg.arg1;
				hisView.showMsgToast(errorMsg + errorCode, Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_SUCCESS:
				if (!checkViewAvailable())
					return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息成功，请在扫码界面中查看详细信息", Toast.LENGTH_SHORT);
				break;
			case RequestConstant.PROT_REQ_CHECK_LABEL_FAIL:
				if (!checkViewAvailable())
					return;
				dismissProgress();
				hisView.showMsgToast("检测标签信息失败", Toast.LENGTH_SHORT);
				break;
			}
		};
	};

	public CommonFarmersPackSubListPresenter(Context context, OptionHisListStyleConstact.View hisView,Intent intent) {
		super(hisView, context);
		this.hisView = hisView;
		this.context = context;
		currentPackBean = (PackBean) intent.getSerializableExtra("currentPackBean");
		option_id = currentPackBean.getId();
		start();
	}

	@Override
	public void start() {
		if (!checkViewAvailable())
			return;
		packageBll = new PackPackageBll(context);
//		bll = new ActivateWithPackBll(context);
		configBll = new ConfigBll(context);
		hisView.setPageTitle("打包");
		hisView.setMoreOptionText("上传");
		hisView.setBottomText("去打包");
		adapter = new PackageListAdapter(packBeans,currentPackBean.getCount());
		hisView.setAdapter(adapter);
	}

	public void dismissProgress() {
		if (bProgressDialog != null) {
			try {
				DialogUtils.dismissProgressDialog(bProgressDialog);
			} catch (Exception e) {
			}
		}
	}

	/**
	 * 提示正在更新数据
	 */
	protected void showProgressDialog(String titleStr, String tipsMsg) {
		bProgressDialog = DialogUtils.showProgressDialog(bProgressDialog, titleStr, tipsMsg, context);
	}

	private UploadStatusBll getUploadStatusBll() {
		if (uploadStatusBll == null) {
			uploadStatusBll = new UploadStatusBll(context);
		}
		return uploadStatusBll;
	}


	private ProductBll getProductBll() {
		if (productBll == null) {
			productBll = new ProductBll(context);
		}
		return productBll;
	}

	@Override
	public boolean checkViewAvailable() {
		boolean b = false;
		if (hisView != null && context != null) {
			b = true;
		}
		return b;
	}

	@Override
	public void onItemClickListener(int position) {
		if (packBeans.size() == 0) {
			return;
		}
		Intent intent = new Intent(context, SingleLabelScannerActivity.class);
		intent.putExtra("optionMode", option_type);
		intent.putExtra("option_id", option_id);
		intent.putExtra("currentPackBean", currentPackBean);
		intent.putExtra("package_id", packBeans.get(position).getId());
		context.startActivity(intent);
		
		
		// ActivateBean a = packBeans.get(position);
		// LogUtil.d(TConfig.Echo,position + "position:" + a.getProduct_date());
	}

	@Override
	public void onItemLongClickListener(int position) {
		if (!checkViewAvailable())
			return;
		if (packBeans.size() > 0) {
			showOptionDialog(position);
		}

	}

	private void showOptionDialog(final int position) {
		if (operationDialog == null) {
			operationDialog = new OperationDialog(context);
		}
		operationDialog.show();
		operationDialog.setSearchViewVisiable(View.VISIBLE);
		operationDialog.setModifyViewVisiable(View.GONE);
		operationDialog.setDClick(position, new DClick() {

			@Override
			public void modifyClick() {
				// 修改
				if (!checkViewAvailable())
					return;
				Intent intent = new Intent(context, ActivateConfigActivity.class);
				intent.putExtra("isCreate", false);
				intent.putExtra("optionMode", option_type.getOption());
				intent.putExtra("currentHisId", packBeans.get(position).getId());
				hisView.startAcForResult(createActivateConfigReqCode, intent);
			}

			@Override
			public void delClick() {
				// 删除
				if (!checkViewAvailable())
					return;
				String msg = "本条数据还未上传\n\n是否确定删除打包数据？\n\n确定删除后\n\n该数据对应的所有信息都会被删除";
				showWarnTipDialog(msg, position);
			}

			@Override
			public void searckClick() {
				if (!checkViewAvailable())
					return;
				if (!NetWorkUtils.isNetworkConnected(context)) {
					DialogUtils.showSetNetDialog(context);
					return;
				}
				ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
				if (configBean == null) {
					hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
					return;
				}
				if (packBeans == null || packBeans.size() == 0) {
					hisView.showMsgToast("抱歉，当前的打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}

				List<String> labels = getSubLabelBll().queryAllSubLabelStrByPackageId(packBeans.get(position).getId(),option_id,option_type.getOption());
				if (labels == null) {
					hisView.showMsgToast("抱歉，当前的打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}

				if (labels.size() == 0) {
					hisView.showMsgToast("抱歉，当前的打包数据中还没有标签，不可查询", Toast.LENGTH_SHORT);
					return;
				}
				showProgressDialog("提示", "正在检测标签信息，请稍后……");
				long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
				ThreadPoolManager.getThreadPool().execute(new CommonCheckPackLabelThread(mHandler, deviceId,packBeans.get(position).getId(), option_type,
						currentPackBean.getId(), labels, getSubLabelBll()));
			}
		});

	}

	protected PackSubLabelBll getSubLabelBll() {
		if (subLabelBll == null) {
			subLabelBll = new PackSubLabelBll(context);
		}
		return subLabelBll;
	}

	protected void showWarnTipDialog(String msg, final int position) {
		if (tipsDialog == null) {
			tipsDialog = new TipsDialog(context);
		}
		tipsDialog.show();
		tipsDialog.setDelWarnView("警告", msg, position, false, new DSure() {

			@Override
			public void sureClick() {
				// bll.delActivatePackById(packBeans.get(position));
				// packBeans = bll.queryAllActivatePackList();
				// adapter.refreshActivateHisData(packBeans);
				packageBll.deletePackPackageById(packBeans.get(position).getId());
				packBeans = packageBll.queryAllPackPackageDESC(option_id, option_type.getOption());
				adapter.refreshData(packBeans);
				hisView.showMsgToast("删除成功！", Toast.LENGTH_SHORT);
			}
		});

	}

	@Override
	public Handler getHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void backBtnClick() {
		if (!checkViewAvailable())
			return;
		hisView.finishPage();
	}

	@Override
	public void moreOptionClick() {
		if (!checkViewAvailable())
			return;
		if (!NetWorkUtils.isNetworkConnected(context)) {
			DialogUtils.showSetNetDialog(context);
			return;
		}
		ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
		if (configBean == null) {
			hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
			return;
		}
		if (packBeans == null || packBeans.size() == 0) {
			hisView.showMsgToast("抱歉，当前的打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}

		int count = getSubLabelBll().queryLabelCountByOptionId(currentPackBean.getId(), option_type.getOption());
		if (count<= 0) {
			hisView.showMsgToast("抱歉，当前的打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
			return;
		}
		showProgressDialog("提示", "正在提交打包信息，请稍后……");
		long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
		ThreadPoolManager.getThreadPool().execute(new CommonSubmitSinglePackThread(mHandler, deviceId, packageBll,
				getSubLabelBll(), getUploadStatusBll(), currentPackBean));
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		LogUtil.d(TConfig.Echo, "onActivityResult" + " requestCode:" + requestCode + "  resultCode:" + resultCode);

	}

	@Override
	public void onResume() {
		packBeans = packageBll.queryAllPackPackageDESC(option_id, option_type.getOption());
		adapter.refreshData(packBeans);

	}

	@Override
	public void uploadAllHisList() {
		if (!checkViewAvailable())
			return;
		
		Intent intent = new Intent(context, SingleLabelScannerActivity.class);
		intent.putExtra("optionMode", option_type);
		intent.putExtra("option_id", option_id);
		intent.putExtra("currentPackBean", currentPackBean);
//		LogUtil.d(TConfig.Echo, "currentPackBean:" + currentPackBean.toString());
		intent.putExtra("package_id", -1);
		context.startActivity(intent);
//		
//		if (!NetWorkUtils.isNetworkConnected(context)) {
//			DialogUtils.showSetNetDialog(context);
//			return;
//		}
//		ConfigBean configBean = configBll.queryConfigByHandsetMode(currentHansetVersion);
//		if (configBean == null) {
//			hisView.showMsgToast("当前设备还未配置过手持机id，请先配置手持机的设备id", Toast.LENGTH_SHORT);
//			return;
//		}
//		if (packBeans == null || packBeans.size() == 0) {
//			hisView.showMsgToast("抱歉，当前的打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
//			return;
//		}
//
//		List<PackPackageInfoBean> valid = getValidActivate();
//		if (valid == null || valid.size() == 0) {
//			hisView.showMsgToast("抱歉，当前的打包数据中都没有标签，不可上传", Toast.LENGTH_SHORT);
//			return;
//		}
//		showProgressDialog("提示", "正在提交打包信息，请稍后……");
//		long deviceId = Long.parseLong(ReadDeviceIDUtil.readScanDecrypt(configBean.getDeviceId()));
//		ThreadPoolManager.getThreadPool().execute(new CommonSubmitAllActivateWithPackThread(mHandler, deviceId, bll,
//				getSingelLabelBll(), getBatchLabelBll(), getUploadStatusBll(), valid));
	}
}

